<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>Registry.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">protean-tests</a> &gt; <a href="index.source.html" class="el_package">io.gitlab.littlesaints.protean.resources</a> &gt; <span class="el_source">Registry.java</span></div><h1>Registry.java</h1><pre class="source lang-java linenums">/*
 *                     protean-core
 *              Copyright (C) 2018 Varun Anand
 *
 * This file is part of protean-core.
 *
 * protean-core is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * at your option) any later version.
 *
 * protean-core is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see &lt;http://www.gnu.org/licenses/&gt;.
 */

package io.gitlab.littlesaints.protean.resources;

import java.util.HashMap;
import java.util.Map;
import java.util.Optional;
import java.util.stream.Stream;

/**
 * A Generic repository to support service lookup.
 *
 * @param &lt;T&gt; The getType of service / resource.
 */
<span class="fc" id="L33">public class Registry&lt;T&gt; {</span>

<span class="fc" id="L35">	private Map&lt;String, T&gt; registry = new HashMap&lt;&gt;(2);</span>

	public Optional&lt;T&gt; lookup(String type) {
<span class="fc" id="L38">		return Optional.ofNullable(registry.get(type));</span>
	}

	public T lookupOrThrow(String name, String type) {
<span class="pc" id="L42">		return lookup(name).orElseThrow(() -&gt; new RuntimeException(&quot;Unable to lookup &quot; + type + &quot; newInstance name &quot; + name + &quot; !!&quot;));</span>
	}

	public Optional&lt;T&gt; register(String type, T resource) {
<span class="fc" id="L46">		return Optional.ofNullable(registry.put(type, resource));</span>
	}

	public Stream&lt;T&gt; stream() {
<span class="fc" id="L50">		return registry.values().stream();</span>
	}

}
</pre><div class="footer"><span class="right">Created with <a href="http://www.jacoco.org/jacoco">JaCoCo</a> 0.8.4.201905082037</span></div></body></html>